unit kutje;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus, ExtCtrls;

type
{  Ttime = Record
    id : integer;
    tijd : string;
  end;
 }
  filter   = record
    roodmin:     Integer;
    roodmax:     Integer;
    groenmin:    Integer;
    groenmax:    Integer;
    blauwmin:    Integer;
    blauwmax:    Integer;
    pixel:       Integer;
    change:      Integer
end;


  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    MainMenu1: TMainMenu;
    file1: TMenuItem;
    open1: TMenuItem;
    filter1: TMenuItem;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    Button2: TButton;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button3: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label5: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Timer2: TTimer;
    CheckBox3: TCheckBox;
    Memo1: TMemo;
    CheckBox4: TCheckBox;
    ListBox1: TListBox;
    Edit5: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure open1Click(Sender: TObject);
    procedure t(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure grabframe;
    procedure filteren;
    procedure changing;
    procedure blok2;
    procedure blok2check;
    procedure Timer2Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure connect;
    procedure disconnect;
//    procedure treintje;
  private
     hWndC : THandle;
  public


  end;

var
  Form1:      TForm1;
  setgeel:    Integer;
  geel:       filter;
  BitMap:     TBitmap;
  trein:      bool;
//  Tijden:     array[0..150] of Ttime;
  nxt:        integer;
  xb,xb2:      Integer;
  yb,yb2:      Integer;
implementation

uses unit2;
{$R *.DFM}

 function capCreateCaptureWindowA(lpszWindowName : PCHAR; dwStyle : longint;
           x : integer; y : integer; nWidth : integer; nHeight :integer;
            ParentWin : HWND; nId : integer)
            : HWND; STDCALL EXTERNAL 'AVICAP32.DLL';

procedure tform1.connect;
begin
hWndC := capCreateCaptureWindowA('trein', WS_Child, 0, 0, 320, 240, form1.handle, 0);
   if hWndC <> 0 then
     SendMessage(hWndC,WM_USER + +10, 0, 0) //WM_CAP_DRIVER_CONNECT
   else showmessage('no webcam found')  ;

end;

procedure tform1.disconnect;
begin
  SendMessage(hWndC,WM_USER + 11, 0, 0); //WM_CAP_DRIVER_DISCONNECT
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if (timer2.enabled) then timer2.Enabled:=false;
  if (timer2.Enabled=false) then timer2.enabled:=true;
end;

procedure TForm1.open1Click(Sender: TObject);
begin
  close()

end;

procedure TForm1.t(Sender: TObject);
begin
  showform2;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
prv,x : integer;
begin
StatusBar1.Panels[0].Text := FormatDateTime('dd-mm-yyyy',Date) + '  ' + TimeToStr(Time);
  {
if prv <> nxt then  //PAS OP,lelijk
begin
prv := nxt;
for x := 0 to ListBox1.Items.Count - 1 do
begin
if (tijden[x].id = nxt) then
edit1.Text := 'Trein van '+ tijden[x].tijd;
end;
end;
   }
end;

procedure TForm1.FormCreate(Sender: TObject);
var
x,start : integer;
begin
BitMap := TBitMap.create;
connect;
xb:=100;
yb:=125;
xb2:=140;
yb2:=110;
trein:=false;

geel.roodmin:=220;
geel.roodmax:=256;

geel.groenmin:=180;
geel.groenmax:=250;

geel.blauwmin:=0;
geel.blauwmax:=120;
geel.change:=12;
bitmap.free;

{start := 0;        //PAS OP, lelijk
Memo1.Clear;
Edit5.clear;
ListBox1.Items.LoadFromFile('c:\tijden.txt');
for x := 0 to ListBox1.Items.Count - 1 do
begin
tijden[x].tijd := ListBox1.Items.Strings[x];
tijden[x].id := x + 1;
if (tijden[x].tijd > FormatDateTime('hh:nn',time)) and (start = 0) then
begin
edit5.Text := 'Trein van '+ tijden[x].tijd;
nxt := tijden[x].id;
start := 1;
end;
end;
 }
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  y,x:integer;
begin
  bitmap:=tbitmap.create;
  bitmap.LoadFromFile('c:\train.bmp');
  canvas.draw(0,0,BitMap);
  bitmap.Free;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  a:                  Integer;
  rood,groen,blauw:   Integer;
begin
  if (checkbox1.checked)then
  begin
    xb:=x;
    yb:=y;
    Screen.Cursor := crDefault;
    checkbox1.checked := false;
    changing;
  end;
  if (checkbox4.checked)then
  begin
    xb2:=x;
    yb2:=y;
    Screen.Cursor := crDefault;
    checkbox4.checked := false;
    blok2;
  end;
  if ((checkbox1.checked =false) and (checkbox4.checked =false))then
  begin
        a := canvas.pixels[x,y];
        rood:= (a and $0000FF);
        groen := round((a and $0000FF00)/$FF);
        blauw := round((a and $00FF0000)/$FF00);
        edit1.Text := IntToStr(rood);
        edit2.Text := IntToStr(groen);
        edit3.Text := IntToStr(blauw);

  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
close
end;

procedure TForm1.filteren;
var

  y,x,a:                  Integer;
  rood,groen,blauw:       Integer;
  totaal:                 Integer;
begin
  y := 0;
  x := 0;
  geel.pixel := 0;
  BitMap := TBitMap.create;
  BitMap.LoadFromFile('c:\train.bmp');
  canvas.draw(0,0,BitMap);
  totaal:=0;
  BitMap.Free;
  for y := yb to (yb+10) do
  begin
     for x := xb to (xb+10) do
      begin
        a := canvas.pixels[x,y];
        rood:= (a and $0000FF);
        groen := round((a and $0000FF00)/$FF);
        blauw := round((a and $00FF0000)/$FF00);

        canvas.pixels[x+(325-xb),y-yb]:=a;
        if ((rood >= geel.roodmin) and (rood <= geel.roodmax))

        and ((groen >= geel.groenmin) and (groen <= geel.groenmax))
        and ((blauw >= geel.blauwmin) and (blauw <= geel.blauwmax))
        then         
        begin
           geel.pixel := geel.pixel + 1;
           canvas.pixels[x,y]:=0;
        end;
           totaal := totaal +1;
      end;
  end;
        edit1.Text := IntToStr(totaal);
        edit2.Text := IntToStr(groen);
        edit3.Text := IntToStr(blauw);
        edit4.text := IntToStr(geel.pixel);

end;


procedure TForm1.changing;
var

  y,x,a,b:                  Integer;
  rood,groen,blauw:       Integer;
  totaal:                 Integer;
begin
  y := 0;
  x := 0;
  geel.pixel := 0;
  BitMap := TBitMap.create;
  BitMap.LoadFromFile('c:\train.bmp');
  canvas.draw(0,0,BitMap);
  totaal:=0;
  BitMap.FreeImage;

  for y := yb to (yb+10) do
  begin
     for x := xb to (xb+10) do
      begin


        a := (canvas.pixels[x,y] and $0000FF);
        b := (canvas.pixels[x+(325-xb),y-yb] and $0000FF);
        rood:= b-a;
        if (rood < 0) then rood := rood * -1;
        rood := round((rood/$FF)*100);
        a := round((canvas.pixels[x,y] and $00FF00)/$FF);
        b := round((canvas.pixels[x+(325-xb),y-yb] and $00FF00)/$FF);
        groen:= b-a;
        if (groen < 0) then groen := groen * -1;
        groen := round((groen/$FF)*100);
        a := round((canvas.pixels[x,y] and $FF0000)/$FF00);
        b := round((canvas.pixels[x+(325-xb),y-yb] and $FF0000)/$FF00);
        blauw:= b-a;
        if (blauw < 0) then blauw := blauw * -1;
        blauw := round((blauw/$FF)*100);
        geel.pixel:=geel.pixel+ round((rood+groen+blauw)/3);
        a := canvas.pixels[x,y];
        canvas.pixels[x+(325-xb),y-yb]:=a;
        totaal := totaal +1;
      end;
  end;
        edit1.Text := IntToStr(rood);
        edit2.Text := IntToStr(groen);
        edit3.Text := IntToStr(blauw);
        geel.pixel:= round(geel.pixel/totaal);
        edit4.text := IntToStr(geel.pixel)+'%';
        if (geel.pixel = 0)then
        begin
          disconnect;
          connect;
        end;

        if (geel.pixel > geel.change) then
        begin
          blok2;
          checkbox2.checked:=true;
        end;

end;

procedure Tform1.blok2;
var
  y,x,a:                  Integer;
  totaal:                 Integer;
begin
  BitMap := TBitMap.create;
  BitMap.LoadFromFile('c:\train.bmp');
  canvas.draw(0,0,BitMap);

  BitMap.Free;

  for y := yb2 to (yb2+10) do
  begin
     for x := xb2 to (xb2+10) do
      begin


      a:=canvas.pixels[x,y];
      canvas.pixels[x+(340-xb2),y-yb2]:=a;
      end;
  end;
end;

procedure Tform1.blok2check;
var

  y,x,a,b:                  Integer;
  rood,groen,blauw:       Integer;
  totaal:                 Integer;
begin
  y := 0;
  x := 0;
  geel.pixel := 0;
  BitMap := TBitMap.create;
  BitMap.LoadFromFile('c:\train.bmp');
  canvas.draw(0,0,BitMap);
  totaal:=0;
  BitMap.Free;
  for y := yb2 to (yb2+10) do
  begin
     for x := xb2 to (xb2+10) do
      begin
        a := (canvas.pixels[x,y] and $0000FF);
        b := (canvas.pixels[x+(340-xb),y-yb2] and $0000FF);
        rood:= b-a;
        if (rood < 0) then rood := rood * -1;
        rood := round((rood/$FF)*100);
        a := round((canvas.pixels[x,y] and $00FF00)/$FF);
        b := round((canvas.pixels[x+(340-xb2),y-yb2] and $00FF00)/$FF);
        groen:= b-a;
        if (groen < 0) then groen := groen * -1;
        groen := round((groen/$FF)*100);
        a := round((canvas.pixels[x,y] and $FF0000)/$FF00);
        b := round((canvas.pixels[x+(340-xb2),y-yb2] and $FF0000)/$FF00);
        blauw:= b-a;
        if (blauw < 0) then blauw := blauw * -1;
        blauw := round((blauw/$FF)*100);
        geel.pixel:=geel.pixel+ round((rood+groen+blauw)/3);
        totaal := totaal +1;
      end;
  end;
        edit1.Text := IntToStr(rood);
        edit2.Text := IntToStr(groen);
        edit3.Text := IntToStr(blauw);
        geel.pixel:= round(geel.pixel/totaal);
        edit4.text := IntToStr(geel.pixel)+'%';

        if (trein=false)then
        begin
          if (geel.pixel > geel.change) then trein:=true;
        end;
        if (trein) then
        begin
          if (geel.pixel < geel.change) then
          begin
            memo1.lines.add(' Er is een Trein gezien om ' +  TimeToStr(Time) + ' op de dag ' + FormatDateTime('dd-mm-yyyy',Date) );
            trein:=false;
            checkbox2.checked:=false;
            //vlak copieren anders blijft die staan er vernaderd er weer heel veel....
              for y := yb to (yb+10) do
                begin
                     for x := xb to (xb+10) do
                           begin
                             a := canvas.pixels[x,y];
                             canvas.pixels[x+(325-xb),y-yb]:=a;
                           end;
                end;
          end;
        end;
end;


procedure TForm1.Timer2Timer(Sender: TObject);
begin

    if (checkbox3.checked)then
    begin
      grabframe;
      if (radiobutton1.checked) then filteren;
      if (radiobutton2.checked and checkbox2.checked=false)then changing;
      if (radiobutton2.checked and checkbox2.checked)then blok2check;
    end;
end;

procedure TForm1.grabframe;
begin
  sendmessage(hWndC, WM_USER + 60,0,0);
  SendMessage(hWndC,WM_USER+25,0,longint(pchar('c:\train.bmp')));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  disconnect;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
if (checkbox1.checked) then Screen.Cursor := crhandpoint;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
if (checkbox4.checked) then Screen.Cursor := crhandpoint;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
if (checkbox3.checked) then trein:=false;
end;

{
procedure TForm1.treintje;
begin
Memo1.Lines.add(edit5.Text + ' kwam om ' + FormatDateTime('hh:nn:ss',time));
nxt := nxt + 1;
end;
 }
end.
